package Go;
// class for a group of stones
public class Group {
   // group's color
   int color;

   //group's stones
   ListOfStones stones;

   // group's liberties
   public ListOfLiberties liberties;

   //constructor; each group has at least one stone
   Group(GobanLocation stone) {
     color = stone.state;

     stones = new ListOfStones();
     stones.add(stone);

     //copy the group's list of liberties from the stone's
     liberties = new ListOfLiberties(stone.liberties);
   }

   Group(int color, ListOfStones stones, ListOfLiberties liberties) {
     this.color = color;
     this.stones = stones;
     this.liberties = liberties;
   }

   public boolean hasNoLiberty() {
     return (liberties.isNone());
   }

   public int nrLiberties() {
     return liberties.length();
   }

   // overriding Object's comparing method
   /** I consider 2 groups to be "equal" if one stone of the first
   * is contained in the second */
   public boolean equals(Object anObject) {
     if (anObject instanceof Group) {
       Group anotherGroup = (Group)anObject;
       if (this.stones.contain(anotherGroup.stones.first()))
         return true;
     }
    return false;
   }

   public synchronized Object clone() {
     ListOfStones clonedStones = (ListOfStones)stones.clone();
     ListOfLiberties clonedLiberties = (ListOfLiberties)liberties.clone();
     return new Group(color, clonedStones, clonedLiberties);
   }

   public String toString() {
     return "[" + color + "; " + "S=" + stones + ";L=" + liberties +"]";
   }

   public int nrStones() {
     return stones.length();
   }
}