package Go;

import Go.strategy.GoStrategy;

// An abstract class modeling a Player in a game of Go
// It is also a GoGameListener in order to know when
// the opponent has moved

public abstract class Player implements GoGameListener{

  public Player() {}

  // constructor
  public Player(int color) {
    this.color = color;
  }

  public void makeMove(GoPosition goPosition) {
    Move newMove;

    newMove = move(goPosition);
    game.newMove(newMove.x, newMove.y);
  }

  public GoStrategy getStrategy() {
    return strategy;
  }

  protected abstract Move move(GoPosition goPosition);

  public void setGame(GoGame game) {
    this.game = game;
  }

  public abstract void initPlayer();

  public int color;
  protected GoGame game;
  protected GoStrategy strategy;  
}