package Go.strategy;

import Go.Move;
import Go.GoPosition;
import Go.GoConstants;

// The purpose of this class is to wrap all the information that should
// be associated with a node in a Go game tree
public class GoNodeInfo {

  public GoNodeInfo(float estimatedValue, Move lastMove, GoPosition position) {
    this.estimatedValue = estimatedValue;
    this.lastMove = lastMove;
    this.nextMove = null;
    this.position = position;
  }

  public int turn() {
    if (lastMove.color == GoConstants.BLACK)
      return GoConstants.WHITE;
    else
      return GoConstants.BLACK;
  }

  // I made these members public for performance reasons, because they are
  // accessed very often during game tree analysis
  public float estimatedValue;
  public Move lastMove;
  public Move nextMove;  
  public GoPosition position;
}