package Manager;

import Go.*;
//import LearningManager.*;
//import TDlearning.*;
import Goban.GobanView;
//import NeuralNetwork.*;
//import environment.*;

import Go.strategy.*;
import java.awt.Frame;
import java.io.IOException;

public class GameManager {

  public GameManager() {
  }

  public GoGame createGame(int boardSize,
                           String blackPlayerType,
                           String whitePlayerType) {

    if (blackPlayer != null) {
      blackPlayer = null;
    }
    if (whitePlayer != null) {
      whitePlayer = null;
    }

    this.boardSize = boardSize;

    // create the black player
    if (blackPlayerType.equals(GoConstants.ptHumanPlayer))
      blackPlayer = createHumanPlayer(GoConstants.BLACK);
    else if (blackPlayerType.equals(GoConstants.ptGreedyComputerPlayer))
      blackPlayer = createGreedyPlayer(GoConstants.BLACK);
    else if (blackPlayerType.equals(GoConstants.ptMinMaxComputerPlayer))
      blackPlayer = createMinMaxPlayer(GoConstants.BLACK);

    else if (blackPlayerType.equals(GoConstants.ptAlphaBetaComputerPlayer))
      blackPlayer = createAlphaBetaPlayer(GoConstants.BLACK);
    /*else if (blackPlayerType.equals(GoConstants.ptTDComputerPlayer))
      blackPlayer = createTDComputerPlayer(GoConstants.BLACK);*/

    // create the white player
    if (whitePlayerType.equals(GoConstants.ptHumanPlayer))
      whitePlayer = createHumanPlayer(GoConstants.WHITE);
    else if (whitePlayerType.equals(GoConstants.ptGreedyComputerPlayer))
      whitePlayer = createGreedyPlayer(GoConstants.WHITE);
    else if (whitePlayerType.equals(GoConstants.ptMinMaxComputerPlayer))
      whitePlayer = createMinMaxPlayer(GoConstants.WHITE);
    else if (whitePlayerType.equals(GoConstants.ptAlphaBetaComputerPlayer))
      whitePlayer = createAlphaBetaPlayer(GoConstants.WHITE);
/*    else if (whitePlayerType.equals(GoConstants.ptTDComputerPlayer))
      whitePlayer = createTDComputerPlayer(GoConstants.WHITE);*/

    goGame = new AtariGoGame(boardSize, blackPlayer, whitePlayer);

    playerSettings(blackPlayer, goGame);
    playerSettings(whitePlayer, goGame);

    return goGame;
  }

  public void registerGobanView(GobanView gobanView) {
    //gobanView.removeAllMoveInputDeviceListeners();
    if (blackPlayer instanceof HumanGoPlayer)
      gobanView.addMoveInputDeviceListener((HumanGoPlayer)blackPlayer);
    if (whitePlayer instanceof HumanGoPlayer)
      gobanView.addMoveInputDeviceListener((HumanGoPlayer)whitePlayer);
  }

  public void unregisterGobanView(GobanView gobanView) {
    gobanView.removeAllMoveInputDeviceListeners();
  }

  public Player getBlackPlayer() {
    return blackPlayer;
  }

  public Player getWhitePlayer() {
    return whitePlayer;
  }

  protected HumanGoPlayer createHumanPlayer(int color) {
    return new HumanGoPlayer(color);
  }

  protected AtariGoGreedyPlayer createGreedyPlayer(int color) {
    return new AtariGoGreedyPlayer(color);
  }

  protected AtariGoMinMaxPlayer createMinMaxPlayer(int color) {
    return new AtariGoMinMaxPlayer(color,
                 new MinMaxGoStrategy(color,
                       new AtariGoEstimatorCho()));
  }

  protected AtariGoMinMaxPlayer createAlphaBetaPlayer(int color) {
    return new AtariGoMinMaxPlayer(color,
                 new AlphaBetaPruningGoStrategy(color,
                       new AtariGoEstimatorCho()));
  }

  /*protected TDPlayer createTDComputerPlayer(int color) {
    return new TDPlayer(color, true);
  } */

  protected void playerSettings(Player player, GoGame goGame) {
    if (player instanceof HumanGoPlayer) {
      //GobanView goban = new GobanView(goGame.goPosition);
      //goban.addMoveInputDeviceListener((HumanGoPlayer)player);

      //goGame.addListener(goban);
    }
    else if ((player instanceof AtariGoGreedyPlayer) ||
             (player instanceof AtariGoMinMaxPlayer))
      player.setGame(goGame);
    /*else if (player instanceof TDPlayer) {
      TDParameters tdParameters = new TDParameters(parentFrame);
      tdParameters.loadFromFile();

      NeuralNetwork neuralNetwork = new NeuralNetwork((boardSize * boardSize),
                                                       tdParameters.hiddenLayerSize);

      if (tdParameters.randomInitNetwork != 0)
        neuralNetwork.initializeWeights();
      else
        try {
          neuralNetwork.loadFromFile(tdParameters.neuralNetworkFile);
        } catch (IOException e) {
          System.out.println("Cannot load NeuralNetwork from file " +
                             tdParameters.neuralNetworkFile);
          System.out.println("I'll perform a random initialization for you");
          neuralNetwork.initializeWeights();
        }

      Environment environment = new AtariGo_Environment((boardSize * boardSize),
                                                        (AtariGoGame)goGame);

      SingleOutput_TDLearning tdLearning = new SingleOutput_TDLearning(neuralNetwork,
                                                                       environment,
                                                                       tdParameters.alpha,
                                                                       tdParameters.beta,
                                                                       tdParameters.lambda);

      ((TDPlayer)player).setTDLearning(tdLearning);
    }*/
  }

  private int boardSize = 5;

  private GoGame goGame;

  private Player blackPlayer;
  private Player whitePlayer;
}
